Package uk.ac.starlink.table.join

# Enum Class ErrorSummation

java.lang.Object
java.lang.Enum<ErrorSummation>
uk.ac.starlink.table.join.ErrorSummation

All Implemented Interfaces:
  `Serializable`, `Comparable<ErrorSummation>`, `Constable`

public enum ErrorSummation extends Enum<ErrorSummation>
Defines how two errors are combined to define a separation threshold.

Since:
  15 May 2024
Author:
  Mark Taylor

## Nested Class Summary

## Nested classes/interfaces inherited from class java.lang.Enum

`Enum.EnumDesc<E extends Enum<E>>`

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`QUADRATURE`
Combines errors by addition in quadrature.
`SIMPLE`
Combines errors by simple addition.

## Method Summary

Modifier and Type
Method
Description
`abstract double`
`combine(double e1, double e2)`
Combines two error values to produce a threshold value for separation.
`abstract double`
`combineSquared(double e1, double e2)`
Returns the square of the result of the `combine` method.
`String`
`getDescription()`
Returns a short human-readable description of the combination method.
`String`
`getTail()`
Returns (possibly empty) text suitable for appending to a matcher description.
`static ErrorSummation`
`valueOf(String name)`
Returns the enum constant of this class with the specified name.
`static ErrorSummation[]`
`values()`
Returns an array containing the constants of this enum class, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### SIMPLE

public static final ErrorSummation SIMPLE
Combines errors by simple addition.

### QUADRATURE

public static final ErrorSummation QUADRATURE
Combines errors by addition in quadrature.

## Method Details

### values

public static ErrorSummation[] values()
Returns an array containing the constants of this enum class, in the order they are declared.

Returns:
  an array containing the constants of this enum class, in the order they are declared

### valueOf

public static ErrorSummation valueOf(String name)
Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum class has no constant with the specified name
  `NullPointerException` - if the argument is null

### combine

public abstract double combine(double e1, double e2)
Combines two error values to produce a threshold value for separation.

Parameters:
  `e1` - first error
  `e2` - second error
Returns:
  threshold value for largest separation that counts as a match

### combineSquared

public abstract double combineSquared(double e1, double e2)
Returns the square of the result of the `combine` method.

This method is provided in case there is a more efficient implementation than the obvious one.

Parameters:
  `e1` - first error
  `e2` - second error
Returns:
  numerically equal to `combine(e1,e2)*combine(e1,e2)`

### getDescription

public String getDescription()
Returns a short human-readable description of the combination method.

Returns:
  description

### getTail

public String getTail()
Returns (possibly empty) text suitable for appending to a matcher description.

Returns:
  tail string; may be empty but not null